<?php

/*
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Forum
 * @package    QuickTalk
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @license    http://www.php.net/license  PHP License 3.0
 * @version    1.9.0.3 build:20081001
 * @link       http://www.qt-cute/doc/package/qtg
 * @since      File available since Release 1.0.0
 * @deprecated File deprecated in Release 2.0.0
 *
 */

session_start();
require_once('bin/qtf_init.php');
include(Translate('qtf_lang_adm.inc'));
if ( $oVIP->role!='A' ) die($L['E_admin']);

include(Translate('qtfm_map.inc'));
include(Translate('qtfm_map_adm.inc'));
include('qtfm_map_lib.php');

// INITIALISE

$oVIP->selfurl = 'qtfm_map_adm.php';
$oVIP->selfname = 'Map';
$oVIP->exiturl = $oVIP->selfurl;
$oVIP->exitname = $oVIP->selfname;
$strPageversion = $L['map_adm']['Version'].' 1.9<br/>';

// read values
foreach (array('m_map_gkey','m_map_gcenter','m_map_gzoom','m_map_gbuttons','m_map_gsymbol') as $strValue)
{
  if ( !isset($_SESSION[QT][$strValue]) )
  {
  $arr = GetParam(true,'param="'.$strValue.'"');
  if ( empty($arr) ) die('<span class="error">Parameters not found. The module is probably not installed properly.</span><br/><br/><a href="qtf_adm_index.php">&laquo;&nbsp;'.$L['Exit'].'</a>');
  }
}

$arrSections = GetSectionTitles('A',-1,-1,'',QTF_SHOW_DOMAIN);

// Read png in directory

$intHandle = opendir('qtfm_map');
$arrFiles = array();
while ( false!==($strFile = readdir($intHandle)) )
{
  if ( $strFile!='.' && $strFile!='..' ) {
  if ( substr($strFile,-4,4)=='.png' ) {
  if ( !strstr($strFile,'shadow') ) {
    $arrFiles[substr($strFile,0,-4)]=ucfirst(substr(str_replace('_',' ',$strFile),0,-4));
  }}}
}
closedir($intHandle);
asort($arrFiles);

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  $_SESSION[QT]['m_map_gkey'] = trim($_POST['m_map_gkey']); if ( strlen($_SESSION[QT]['m_map_gkey'])<8 ) $_SESSION[QT]['m_map_gkey']='';
  $_SESSION[QT]['m_map_gcenter'] = trim($_POST['m_map_gcenter']);
  $_SESSION[QT]['m_map_gzoom'] = trim($_POST['m_map_gzoom']);
  $_SESSION[QT]['m_map_gbuttons'] = substr($_POST['maptype'],0,1).(isset($_POST['nav']) ? '1' : '0').(isset($_POST['map']) ? '1' : '0').(isset($_POST['scale']) ? '1' : '0').(isset($_POST['overview']) ? '1' : '0').(isset($_POST['mousewheel']) ? '1' : '0');
  $_SESSION[QT]['m_map_gfind'] = trim($_POST['m_map_gfind']);  

  $_SESSION[QT]['m_map_gsymbol'] = trim($_POST['strL']).' '.trim($_POST['strA']).' '.trim($_POST['strM']).' '.trim($_POST['strU']);
  $_SESSION[QT]['m_map_gsymbol'] .= ' '.(file_exists('qtfm_map/'.$_POST['strA'].'_shadow.png') ? '1' : '0').(file_exists('qtfm_map/'.$_POST['strM'].'_shadow.png') ? '1' : '0').(file_exists('qtfm_map/'.$_POST['strU'].'_shadow.png') ? '1' : '0');
  $_SESSION[QT]['m_map_gsymbol'] .= ' '.(file_exists('qtfm_map/'.$_POST['strA'].'.gif') ? '1' : '0').(file_exists('qtfm_map/'.$_POST['strM'].'.gif') ? '1' : '0').(file_exists('qtfm_map/'.$_POST['strU'].'.gif') ? '1' : '0');
  $_SESSION[QT]['m_map_gsymbol'] .= ' '.(file_exists('qtfm_map/'.$_POST['strA'].'_shadow.gif') ? '1' : '0').(file_exists('qtfm_map/'.$_POST['strM'].'_shadow.gif') ? '1' : '0').(file_exists('qtfm_map/'.$_POST['strU'].'_shadow.gif') ? '1' : '0');

  // save value
  if ( empty($qtf_error) )
  {
    $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$_SESSION[QT]['m_map_gkey'].'" WHERE param="m_map_gkey"');
    $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$_SESSION[QT]['m_map_gcenter'].'" WHERE param="m_map_gcenter"');
    $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$_SESSION[QT]['m_map_gzoom'].'" WHERE param="m_map_gzoom"');
    $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$_SESSION[QT]['m_map_gbuttons'].'" WHERE param="m_map_gbuttons"');
    $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$_SESSION[QT]['m_map_gfind'].'" WHERE param="m_map_gfind"');
    $oDB->Query('UPDATE '.TABSETTING.' SET setting="'.$_SESSION[QT]['m_map_gsymbol'].'" WHERE param="m_map_gsymbol"');
  }
  
}

// --------
// HTML START
// --------

// prepare section settings

if ( !isset($_SESSION[QT]['m_map_gsymbol']) ) $_SESSION[QT]['m_map_gsymbol']='1 0 0 0 111 111 000';
$arr = explode(' ',$_SESSION[QT]['m_map_gsymbol']);
$strL = $arr[0]; //memberlist [0/1]
$strA = $arr[1]; //symbol Admins (0 or filename)
$strM = $arr[2]; //symbol Moderators (0 or filename)
$strU = $arr[3]; //symbol Users (0 or filename)

// DISPLAY

if ( !empty($_SESSION[QT]['m_map_gkey']) )
{ 
  $strHeaderAddScript = QTgmapheader();
  $strBodyAddOnunload='GUnload()';
}

$arrJava = array('com'=>false);

include('qtf_adm_p_header.php');
include('qtf_adm_p_title.php');

echo '<form method="post" action="',$oVIP->selfurl,'">
<table class="ta" cellspacing="0">
<colgroup span="3"><col width="150"></col><col width="250"></col><col></col></colgroup>
';
echo '<tr class="tr tr_o">
<th class="th_o th_o_all" colspan="3">',$L['map_adm']['Mapping_settings'],'</th>
</tr>
';
echo '<tr class="tr tr_o">
<th class="th_o th_o_first"><label for="m_map_gkey">',$L['map_adm']['API_key'],'</label></th>
<td class="td_o" colspan="2">
<input type="text" id="m_map_gkey" name="m_map_gkey" class="small" size="90" maxlength="100" value="',$_SESSION[QT]['m_map_gkey'],'" style="background-color:#FFFF99"/>
</td>
</tr>
';
echo '<tr class="tr tr_o">
<th class="th_o th_o_first">',$L['map_adm']['API_ctrl'],'</th>
<td class="td_o" colspan="2">
<input type="checkbox" id="nav" name="nav"'.(substr($_SESSION[QT]['m_map_gbuttons'],1,1)=='1' ? QCHE : '').' style="vertical-align: middle"/><label for="nav">',$L['map_adm']['Ctrl_navigation'],'</label>
&nbsp;<input type="checkbox" id="map" name="map"'.(substr($_SESSION[QT]['m_map_gbuttons'],2,1)=='1' ? QCHE : '').' style="vertical-align: middle"/><label for="map">',$L['map_adm']['Ctrl_background'],'</label>
&nbsp;<input type="checkbox" id="scale" name="scale"'.(substr($_SESSION[QT]['m_map_gbuttons'],3,1)=='1' ? QCHE : '').' style="vertical-align: middle"/><label for="scale">',$L['map_adm']['Ctrl_scale'],'</label>
&nbsp;<input type="checkbox" id="overview" name="overview"'.(substr($_SESSION[QT]['m_map_gbuttons'],4,1)=='1' ? QCHE : '').' style="vertical-align: middle"/><label for="overview">',$L['map_adm']['Ctrl_overview'],'</label>
&nbsp;<input type="checkbox" id="mousewheel" name="mousewheel"'.(substr($_SESSION[QT]['m_map_gbuttons'],5,1)=='1' ? QCHE : '').' style="vertical-align: middle"/><label for="mousewheel">',$L['map_adm']['Ctrl_mousewheel'],'</label>
</td>
</tr>
';

// ----------
if ( !empty($_SESSION[QT]['m_map_gkey']) ) {
// ----------

echo '<tr class="tr tr_o">
<th class="th_o th_o_first">',$L['map_adm']['Memberlist'],'</th>
<td class="td_o">
<select id="strL" name="strL" size="1">
<option value="0"',($strL=='0' ? QSEL : ''),'>',$L['N'],'</option>
<option value="1"',($strL=='1' ? QSEL : ''),'>',$L['Y'],'</option>
</select>
</td>
<td class="td_o"><span class="help">',$L['map_adm']['H_Memberlist'],'</span></td>
</tr>
';

echo '<tr class="tr tr_o">
<th class="th_o th_o_first">',$L['map_adm']['Symbol'],'</th>
<td class="td_o" colspan="2">
<table class="ta_hidden">
';
foreach ( array('A','M','U') as $strKey )
{
$str=QTgetsymbol($strKey,'icon'); if ( !$str ) $str='0';
echo '
<tr onmouseover="this.style.backgroundColor=\'#eeeeee\';" onmouseout="this.style.backgroundColor=\'#ffffff\';">
<td style="width:150px">
',$L['Userroles'][$strKey],'</td>
<td>
<select class="small" id="str',$strKey,'" name="str',$strKey,'" size="1">
<option value="0"'.($str=='0' ? QSEL :'').'>',$L['map_adm']['Default'],'</option>
<option value="-" disabled="disabled">-----------</option>
',QTastags($arrFiles,null,$str),'
</select>
</td>
</tr>
';
}

echo '</table>
</td>
</tr>
';

// ----------
}
// ----------

echo '<tr class="tr tr_o">
<th class="th_o th_o_all" colspan="3">',$L['map_adm']['Mapping_config'],'</th>
</tr>
';
echo '<tr class="tr tr_o">
<th class="th_o th_o_first"><label for="m_map_gcenter">',$L['map_adm']['Center'],'</label></th>
<td class="td_o"><input type="text" id="m_map_gcenter" name="m_map_gcenter" size="28" maxlength="100" value="',$_SESSION[QT]['m_map_gcenter'],'"/><span class="small"> ',$L['map_adm']['Latlng'],'</span></td>
<td class="td_o"><span class="help">',$L['map_adm']['H_Center'],'</span></td>
</tr>
';
echo '<tr class="tr tr_o">
<th class="th_o th_o_first"><label for="m_map_gzoom">',$L['map_adm']['Zoom'],'</label></th>
<td class="td_o">
<input type="text" id="m_map_gzoom" name="m_map_gzoom" size="2" maxlength="2" value="',$_SESSION[QT]['m_map_gzoom'],'"/></td>
<td class="td_o"><span class="help">',$L['map_adm']['H_Zoom'],'</span></td>
</tr>
';
echo '<tr class="tr tr_o">
<th class="th_o th_o_first">',$L['map_adm']['Background'],'</th>
<td class="td_o"><select id="maptype" name="maptype" size="1">',QTastags($L['map_adm']['Back'],null,substr($_SESSION[QT]['m_map_gbuttons'],0,1)),'</select></td>
<td class="td_o"><span class="help">',$L['map_adm']['H_Background'],'</span></td>
</tr>
';
echo '<tr class="tr tr_o">
<th class="th_o th_o_first"><label for="m_map_gfind">',$L['map_adm']['Address_sample'],'</label></th>
<td class="td_o">
<input type="text" id="m_map_gfind" name="m_map_gfind" size="20" maxlength="100" value="',$_SESSION[QT]['m_map_gfind'],'"/></td>
<td class="td_o"><span class="help">',$L['map_adm']['H_Address_sample'],'</span></td>
</tr>
';
echo '<tr class="tr tr_o">
<th class="th_o th_o_all" colspan="3" style="padding:6px; text-align:center"><input type="submit" name="ok" value="',$L['Save'],'"/></th>
</tr>
';
echo '</table>
</form>
';

echo '
<table class="ta_hidden" cellspacing="0">
<tr class="tr_hidden">
<td class="td_hidden">

<h2>',$L['map_adm']['Preview'],'</h2>
<table class="ta" style="width:460px;" cellspacing="0">
<tr class="tr tr_o">
<td class="td_o">';
if ( empty($_SESSION[QT]['m_map_gkey']) )
{
  echo '<p class="disabled">',$L['map_adm']['E_disabled'],'</p>';
}
else
{
  echo '<p class="small" style="margin:2px 0 4px 2px;text-align:right">',$L['map']['canmove'],' | <a class="small" href="javascript:void(0)" onclick="undoChanges(); return false;"/>',$L['map']['undo'],'</a></p>',N;
  echo '<div id="map_canvas" style="width:500px; height:350px;"></div><input type="hidden" id="m_map_gcenter" name="m_map_gcenter" value=""/>',N;
  echo '<p class="small" style="margin:4px 0 2px 2px;text-align:right">',$L['map']['addrlatlng'],' <input type="text" size="24" id="find" name="find" class="small" value="',$_SESSION[QT]['m_map_gfind'],'" onKeyUp="handle_keypress(event,\'findit\')" title="',$L['map']['H_addrlatlng'],'"/> <input type="submit" id="findit" class="small" onclick="showLocation(document.getElementById(\'find\').value); return false;" value="',$L['Search'],'"/></p>',N;
}
echo '</td>
</tr>
</table>

</td>
<td class="td_hidden">

<h2>',$L['map_adm']['Other_symbols'],'</h2>
<table class="ta" cellspacing="0">
';
foreach ($arrFiles as $strFile=>$strName)
{
  echo '<tr class="tr tr_o"><td class="td_o"><img src="qtfm_map/',$strFile,'.png"/></td><td class="td_o"><span class="small">',$strName,'</span></td></tr>';
}
echo '
</table>

</td>
</tr>
</table>
';

// HTML END

if ( !empty($_SESSION[QT]['m_map_gkey']) )
{
  // map loader
  $x = QTgetx($_SESSION[QT]['m_map_gcenter']); //if ( empty($x) ) $x=0.0;
  $y = QTgety($_SESSION[QT]['m_map_gcenter']); //if ( empty($y) ) $y=0.0;
  $oMapPoint = new cMapPoint($y,$x,$L['map_adm']['Default_center'],'',false);
  echo '
  <script type="text/javascript">
  <!--
  '.QTgmappoints($L['map'],$y,$x,'drag',array($oMapPoint),true).'
  function mapsection(section)
  {
    if (document.getElementById("sec_"+section).checked)
    {
    document.getElementById("label_mark_"+section).style.visibility="visible";
    document.getElementById("mark_"+section).style.visibility="visible";
    document.getElementById("list_"+section).style.visibility="visible";
    document.getElementById("label_list_"+section).style.visibility="visible";
    }
    else
    {
    document.getElementById("label_mark_"+section).style.visibility="hidden";
    document.getElementById("mark_"+section).style.visibility="hidden";
    document.getElementById("list_"+section).style.visibility="hidden";
    document.getElementById("label_list_"+section).style.visibility="hidden";
    }
    return null;
  }
  mapload();
  -->
  </script>
  ';
}

include('qtf_adm_p_footer.php');

?>
