<?php

/*
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Forum
 * @package    QuickTalk
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2008-2012 The PHP Group
 * @license    http://www.php.net/license  PHP License 3.0
 * @version    1.9.0.3 build:20081001
 * @link       http://www.qt-cute/doc/package/qtg
 * @since      File available since Release 1.0.0
 * @deprecated File deprecated in Release 2.0.0
 *
 */

session_start();
require_once('bin/qtf_init.php');
include(Translate('qtf_lang_adm.inc'));
if ( $oVIP->role!='A' ) die($L['E_admin']);

// INITIALISE

$strVersion='v1.9';

$oVIP->selfurl = 'qtfm_map_install.php';
$oVIP->selfname = 'Installation module MAP '.$strVersion;

$bStep1 = true;
$bStepZ = true;

// STEP 1

$strFile = 'qtfm_map_uninstall.php';
if ( !file_exists($strFile) ) $qtf_error='Missing file: '.$strFile.'<br/>This module cannot be used.';
$strFile = 'qtfm_map_adm.php';
if ( !file_exists($strFile) ) $qtf_error='Missing file: '.$strFile.'<br/>This module cannot be used.';
if ( !empty($qtf_error) ) $bStep1 = false;

// STEP Z
if ( empty($qtf_error) )
{
  $oDB->Query('DELETE FROM '.TABSETTING.' WHERE param="module_map" OR param="m_map_gkey" OR param="m_map_gcenter" OR param="m_map_gzoom" OR param="m_map_gbuttons"');
  $oDB->Query('INSERT INTO '.TABSETTING.' (param,setting,loaded) VALUES ("module_map","Map","0")');
  $oDB->Query('INSERT INTO '.TABSETTING.' (param,setting,loaded) VALUES ("m_map_gkey","","0")');
  $oDB->Query('INSERT INTO '.TABSETTING.' (param,setting,loaded) VALUES ("m_map_gcenter","50.8468142558,4.35238838196","0")');
  $oDB->Query('INSERT INTO '.TABSETTING.' (param,setting,loaded) VALUES ("m_map_gzoom","10","0")');
  $oDB->Query('INSERT INTO '.TABSETTING.' (param,setting,loaded) VALUES ("m_map_gbuttons","P11100","0")');
  $oDB->Query('INSERT INTO '.TABSETTING.' (param,setting,loaded) VALUES ("m_map_gfind","Brussels, Belgium","0")');
  $oDB->Query('INSERT INTO '.TABSETTING.' (param,setting,loaded) VALUES ("m_map_gsymbol","1 0 0 0 111 111 000","0")');
  $_SESSION[QT]['module_map'] = 'Map';
  $_SESSION[QT]['m_map_gkey'] = '';
  $_SESSION[QT]['m_map_gcenter'] = '50.8468142558,4.35238838196';
  $_SESSION[QT]['m_map_gzoom'] = '10';
  $_SESSION[QT]['m_map_gbuttons'] = 'P10100';
  $_SESSION[QT]['m_map_gfind'] = 'Brussels, Belgium';
  $_SESSION[QT]['m_map_gsymbol'] = '1 0 0 0 111 111 000';
}

// --------
// Html start
// --------
include('qtf_adm_p_header.php');

echo '
<h1>',$oVIP->selfname,'</h1>
';

echo '<h2>Checking components</h2>';
if ( !$bStep1 )
{
  echo '<p class="error">',$qtf_error,'</p>';
  include('qtf_adm_p_footer.php');
  exit;
}
echo '<p>Ok</p>';
echo '<h2>Database settings</h2>';
if ( !$bStepZ )
{
  echo '<p class="error">',$qtf_error,'</p>';
  include('qtf_adm_p_footer.php');
  exit;
}
echo '<p>Ok</p>';
echo '<h2>Installation completed</h2>';

if ( $_SESSION[QT]['version']=='1.6' )
{
  echo '<p class="error">Your database version is 1.6. We recommand you to upgrade to 1.7 (use the installation wizard of QuickTalk).</p>';
}

// --------
// Html end
// --------

?>